<?
class DH_ConvFS {


	static function touch() {
		foreach ($GLOBALS['gCfg']['storage'] as $name => $value) if ( (substr($name, 0, 4) === 'dir_') and !glob($value) ) mkdir($value, 0755, true);
	}


	static function get_entries($dir) {
		global $gCfg;
		$depth = FS::XBT($dir, $gCfg['types']['video']);
		if ($depth) return FS::recurse($dir, $depth);
		else return array();
	}


	static function get_videos($path) {
		global $gCfg;
		return glob($path.DS.'*.{'.implode(',', Arr::pad_case($gCfg['types']['video'])).'}', GLOB_BRACE);
	}


	static function get_subs($path) {
		global $gCfg;
		$subs = glob($path.DS.'*.{'.implode(',', Arr::pad_case($gCfg['types']['sub'])).'}', GLOB_BRACE);
		if (empty($subs)) {
			$depth = FS::XBT($path, $gCfg['types']['sub']);
			if ($depth) {
				$subdirs = FS::recurse($path, $depth);
				foreach ($subdirs as $subdir) $subs = array_merge($subs, self::get_subs($subdir));
			} else return array();
		}
		return $subs;
	}


	static function match_subs($videos, $subs) {
		global $gErr, $gCl;

		$matches = array();
		$subs_used = array();

		if (!empty($subs)) foreach ($videos as $video) {
			$subs_top = array();
			$found = false;

			foreach ($subs as $sub) {
				if (strcasecmp(String::crop(basename($sub), '.'), String::crop(basename($video), '.')) == 0) {
					$matches[] = compact('video', 'sub');
					$subs_used[] = $sub;
					$found = true;
					break;
				}
				$diff = Sub::match($video, $sub);
				$subs_top[$diff][] = $sub;
			}
			if ($found) continue;

			asort($subs_top);
			$subs_top = reset($subs_top);
			if (count($subs_top) > 1) {
				$gErr->subs->$video->ambigious = 'Титры имеют одну релевантность: '.implode(', ', $subs_top);
				Sub::video($video);
				usort($subs_top, array('Sub', 'compare'));
			}
			foreach ($subs_top as $i => $sub) {
				if ( ($i != (count($subs_top) - 1)) and in_array($sub, $subs_used) ) continue;
				elseif (in_array($sub, $subs_used)) $gErr->subs->$video->repeat = "Титры используются повторно: $sub";
				$subs_used[] = $sub;
				if (!isset($gErr->subs->$video) or in_array('f', $gCl['flags'])) $matches[] = compact('video', 'sub');
				elseif (isset($gErr->subs->$video) and in_array('v', $gCl['flags'])) {
					echo "\n--- $video ($sub):\n{$gErr->subs->$video}\n";
					unset($gErr->subs->$video);
				}
				break;
			}
		} else $gErr->subs->{dirname(reset($videos))}->not_found = 'Титры не найдены в папке '.dirname(reset($videos));
		if (count($subs_used) < count($subs)) $gErr->subs->excess = 'Не все титры были использованы: '.dirname($video);
		return $matches;
	}


	static function post($shot_id, $flv_id, $shot, $flv, $type_id = null) {
		global $gCfg;
		if (is_null($type_id)) $type_id = $gCfg['types']['out_shot_type_id'];

		copy($shot, $gCfg['storage']['dir_usr_shot'].DS.$shot_id.'.'.$gCfg['types']['image'][$type_id]);
		copy($shot, $gCfg['storage']['dir_usr'].DS.$flv_id.'.'.$gCfg['types']['image'][$type_id]);
		copy($flv, $gCfg['storage']['dir_usr'].DS.$flv_id.'.'.$gCfg['types']['out']);

		rename($shot, $gCfg['storage']['dir_dump'].DS.basename($shot));
		rename($flv, $gCfg['storage']['dir_dump'].DS.basename($flv));
	}


}
