<?
class DH_LogDB {


	static function get_name($seed = 0) {
		static $entropy = array();
		if (!isset($entropy[$seed])) $entropy[$seed] = uniqid('cron_logs_');
		return $entropy[$seed];
	}


	static function touch() {
		global $gCfg, $gCl;
		$db = DB::get($gCfg['animebase']);
		$table = self::get_name();
		$permanency = (!in_array('d', $gCl['flags'])) ? 'TEMPORARY' : '';
		$db->e("
			CREATE $permanency TABLE $table (
				dir VARCHAR( 64 ) NOT NULL ,
				ip VARCHAR( 15 ) NOT NULL ,
				size INT( 10 ) UNSIGNED NOT NULL,
				timestamp INT( 10 ) UNSIGNED NOT NULL
			) ENGINE = MYISAM
		");
		$db->e("CREATE UNIQUE INDEX ip__file ON $table (ip,dir)");
	}


	static function log_entry($dir, $ip, $size, $timestamp) {
		$db = DB::get();
		$table = self::get_name();
		return $db->ins($table, compact('dir', 'ip', 'size', 'timestamp'));
	}


	static function commit() {
		global $gCl;
		$db = DB::get();
		$table_base = self::get_name();
		$table_grouped = self::get_name(1);
		$permanency = (!in_array('d', $gCl['flags'])) ? 'TEMPORARY' : '';
		if (in_array('p', $gCl['flags'])) {
			echo "\n\nEntries, discarded on comparison (dir != movie.path):\n";
			$discarded = $db->arr("SELECT c.dir, COUNT(c.ip) AS count FROM $table_base AS c LEFT JOIN m_movie AS m ON c.dir = m.path WHERE ISNULL(m.movie_id) GROUP BY dir");
			if (!empty($discarded)) {
				var_dump($discarded);
				echo 'Count: '.count($discarded)."\n";
			} else echo "No discarded entries on path comparison\n";
		}
		$db->e("CREATE $permanency TABLE $table_grouped AS SELECT m.movie_id, m.path, COUNT(ip) AS count FROM $table_base AS c, m_movie AS m WHERE c.dir LIKE m.path GROUP BY m.movie_id");
		if (!in_array('p', $gCl['flags'])) $db->e("UPDATE m_movie AS m, $table_grouped AS c SET m.popular = m.popular + c.count WHERE m.movie_id = c.movie_id");
		else {
			echo "\n\nFinal results:\n";
			$results = $db->arr("SELECT m.title, c.path, c.count FROM m_movie AS m, $table_grouped AS c WHERE m.movie_id = c.movie_id");
			if (!empty($results)) {
				var_dump($results);
				echo 'Count: '.count($results)."\n";
			} else echo "No results to commit\n";
		}
	}


	static function clean() {
		$db = DB::get();
		$table_base = self::get_name();
		$table_grouped = self::get_name(1);
		$db->e("DROP TEMPORARY TABLE IF EXISTS $table_base");
		$db->e("DROP TEMPORARY TABLE IF EXISTS $table_grouped");
	}


}
