<?
class Job_Convert extends Job {

	public $video, $video_path, $video_id, $video_w, $video_h, $sub, $script, $flv, $sub_type, $sub_enc, $sub_font;
	static $output = array('flv', 'shot');
	static $ssa = array('ssa', 'ass');

	const ENC_UTF8 = 'UTF-8';
	const ENC_CP1251 = 'WINDOWS-1251';


	function __construct($id, $video, $sub) {
		global $gCfg;
		$this->id = $id;
		$this->name = String::base(basename($video), '.');
		$this->video = $video;
		$this->video_path = basename(dirname( (mb_substr($this->video, 0, mb_strlen($gCfg['storage']['ftp_root'])) == $gCfg['storage']['ftp_root']) ? trim(mb_substr($this->video, mb_strlen($gCfg['storage']['ftp_root']))) : trim($this->video) ));
		$this->video_id = DH_ConvDB::resolve($this->video_path);
		if (flag('D')) echo $this->video_path.' === '.$this->video_id."\n";
		$this->shot = $gCfg['storage']['dir_img'].DS.$this->name.'.jpg';
		$this->flv_raw = $gCfg['storage']['dir_tmp'].DS.$this->name.'.'.$gCfg['types']['out'].'.bak';
		$this->flv = $gCfg['storage']['dir_out'].DS.$this->name.'.'.$gCfg['types']['out'];
		$this->sub = $sub;
		$this->sub_type = strtolower(String::crop(basename($this->sub), '.'));
		$this->sub_enc = String::uCheck(file_get_contents($sub)) ? self::ENC_UTF8 : self::ENC_CP1251;
		$this->sub_font = $gCfg['storage']['dir_ttf'].DS.$gCfg['convertor']['sub_font'];
	}


	function commence() {
		$this->status(Job::ST_INIT);
		if (flag('d')) echo "\nStarted job: $this->name\n";
		$this->script = $this->init($this->name);

		$this->status(Job::ST_PREPARE);
		list($result, $output) = $this->prepare();
		if (($result != 0) or flag('d')) $this->log($output);

		$this->status(Job::ST_CONFIGURE);
		$this->configure();

		$this->status(Job::ST_MAKE);
		list($result, $output) = $this->make();
		if ($result != 0) return $this->status(Job::ST_FAILURE, $output);
		else {
			$this->status(Job::ST_CLEAN);
			if (flag('d')) $this->log($output);
			if (flag('z') or !flag('n')) $ids = $this->postproc();
			if (flag('z') and !empty($ids)) $this->finalize($ids);
			if (flag('c')) $this->clean();
		}

		return $this->status(Job::ST_SUCCESS);
	}


	function init($name) {
		global $gCfg;
		$this->script = $gCfg['storage']['dir_js'].DS.$name.'.js';
		touch($this->script);
		return $this->script;
	}


	function prepare() {
		global $gCfg, $gSh;
		$shot = $gSh.$gCfg['convertor']['cmd_shot'];
		$img_samples = $gCfg['convertor']['shot_samples'];

		$result = 0;
		$output = array();
		$out_samples = $res_samples = array();

		$img_size_max = 0;
		$img_i = 0;
		for ($i = 0; $i < $img_samples; $i++) {
			$img_name[$i] = str_replace(basename($this->shot), '_pre'.$i.'_'.basename($this->shot), $this->shot);
			$img_pos = 300 + ($i * 30);
			$out_samples[$i] = $res_samples[$i] = array();
			$shot = $shot.' -y -i '.escapeshellarg($this->video).' -an -ss '.escapeshellarg($img_pos).' -r 1 -vframes 1 -f image2 '.escapeshellarg($img_name[$i]).' 2>&1';
			exec($shot, $out_samples[$i], $res_samples[$i]);
			if (flag('d')) array_unshift($out_samples[$i], $shot);
			if (is_file($img_name[$i])) {
				$img_size[$i] = filesize($img_name[$i]);
				if ($img_size[$i] > $img_size_max) {
					$img_size_max = $img_size[$i];
					$img_i = $i;
				}
			}
		}

		foreach ($img_name as $i => $img_file) {
			if (!is_file($img_name[$i])) continue;
			if ( $i != $img_i ) unlink($img_name[$i]);
			else rename($img_name[$i], $this->shot);
		}

		foreach ($out_samples as $sample) if (is_array($sample) and !empty($sample)) {
			foreach ($sample as $out_line) if (stripos($out_line, 'Video:') !== false) {
				preg_match('/\b(\d+)x(\d+)\b/', $out_line, $video_size);
				$this->video_w = $video_size[1];
				$this->video_h = $video_size[2];
				break;
			}
			if ($this->video_w and $this->video_h) break;
		}

		if (flag('d')) echo "--- Shot ".(is_file($this->shot) ? '' : 'IS NOT ')."prepared: $this->shot\n";
		$result = $res_samples[$img_i];
		$output = !flag('d') ? $out_samples[$img_i] : Arr::flatten($out_samples);

		return array($result, $output);
	}


	function configure() {
		global $gCfg;
		while (@ob_end_flush());
		ob_start();

		$out_w = isset($gCfg['convertor']['flv_w']) ? $gCfg['convertor']['flv_w'] : ($gCfg['convertor']['flv_h'] / $this->video_h) * $this->video_w;
		$out_h = isset($gCfg['convertor']['flv_h']) ? $gCfg['convertor']['flv_h'] : ($gCfg['convertor']['flv_w'] / $this->video_w) * $this->video_h;
		$sub_offset = $out_h - 56;

		if ( in_array($this->sub_type, self::$ssa) and ($this->sub_enc !== self::ENC_UTF8) ) {
			$tmp_file = $gCfg['storage']['dir_tmp'].DS.basename($this->sub);
			$to_enc = self::ENC_UTF8;
			$conversion = file_put_contents($tmp_file, iconv($this->sub_enc, $to_enc.'//IGNORE', file_get_contents($this->sub)));
			if ($conversion !== false) {
				if (flag('d')) $this->log("SubCoversion_success: $this->sub > $tmp_file ($this->sub_enc > $to_enc)");
				$this->sub = $tmp_file;
				$this->sub_enc = self::ENC_UTF8;
			} else $this->log("SubCoversion_FAILURE: $this->sub > $tmp_file ($this->sub_enc > $to_enc)");
		}
?>
//<?=$this->name?>  <- Needed to identify//
var app = new Avidemux();

//** Video **
app.load("<?=$this->video?>");
app.rebuildIndex();

//** Postproc **
app.video.setPostProc(3,3,0);

//** Filters **
app.video.addFilter("resize","w=<?=$out_w?>","h=<?=$out_h?>","algo=1");
app.video.addFilter("resamplefps","newfps=12000","use_linear=0");
<?
if (in_array($this->sub_type, self::$ssa)) { ?>app.video.addFilter("ass","font_scale=1.000000","line_spacing=0.100000","top_margin=0","bottom_margin=0","subfile=<?=$this->sub?>","fonts_dir=<?=$gCfg['storage']['dir_ttf']?>","extract_embedded_fonts=1");<? }
else { ?>app.video.addFilter("subtitle","_fontsize=10","_subname=<?=$this->sub?>","_fontname=<?=$this->sub_font?>","_charset=<?=$this->sub_enc?>","_baseLine=<?=$sub_offset?>","_Y_percent=178","_U_percent=43","_V_percent=0","_selfAdjustable=1","_delay=0","_useBackgroundColor=0","_bg_Y_percent=0","_bg_U_percent=0","_bg_V_percent=0","_blend=1");<? }
?>

//** Video Codec conf **
app.video.codec("FLV1","CBR=192","160 05 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 02 00 00 00 1f 00 00 00 03 00 00 00 00 00 00 00 00 00 00 00 01 00 00 00 fe ff ff ff 01 00 00 00 fb ff ff ff cd cc 4c 3d 01 00 00 00 0a d7 23 3c 01 00 00 00 00 00 00 3f 00 00 00 3f 00 00 00 00 00 00 00 00 00 00 00 00 64 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 02 00 00 00 40 1f 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ");

//** Audio **
app.audio.reset();
app.audio.codec("lame",64,16,"01 00 00 00 02 00 00 00 02 00 00 00 00 00 00 00 ");
app.audio.normalizeMode=0;
app.audio.normalizeValue=0;
app.audio.delay=0;
app.audio.mixer("NONE");
app.audio.resample=22050;

app.setContainer("FLV");
app.save("<?=$this->flv_raw?>");
setSuccess(1);
<?
		$script = ob_get_clean();

		if (is_file($this->script)) unlink($this->script);
		try { file_put_contents($this->script, $script); }
		catch (Exception $ex) { }

		if (flag('d')) echo "--- Script ".(is_file($this->script) ? '' : 'IS NOT ')."prepared: $this->script\n";
	}


	function make() {
		global $gCfg, $gSh;
		$result_demux = $result_compose = 0;
		$output_demux = $output_compose = array();

		$demux = $gSh.'echo "n\nn\nn\nn" | '.$gCfg['convertor']['cmd_demux'].' --nogui --run '.escapeshellarg($this->script).' 2>&1';
		$compose = $gSh.$gCfg['convertor']['cmd_compose'].' -U '.escapeshellarg($this->flv_raw).' '.escapeshellarg($this->flv).' 2>&1';
		if (flag('d')) echo "Commencing make:\n--- demux: $demux\n--- compose: $compose\n";

		exec($demux, $output_demux, $result_demux);
		array_unshift($output_demux, $demux);
		exec($compose, $output_compose, $result_compose);
		array_unshift($output_compose, $compose);

		$result = $result_demux | $result_compose;
		$output = array_merge(array_pad($output_demux, count($output_demux) + 5, ''), $output_compose);
		if (flag('d')) echo "--- FLV ".(is_file($this->flv) ? '' : 'IS NOT ')."ready: $this->flv\n";

		return array($result, $output);
	}


	function postproc($ids = array()) {
		$shot = is_file($this->shot) ? $this->shot : null;
		$flv = is_file($this->flv) ? $this->flv : null;
		if (flag('d')) echo "--- PostProc: video = $this->video_id, shot = $shot, flv = $flv\n";
		if ($shot and $flv) $ids[] = DH_ConvDB::process($this->video_id, $shot, $flv);
		return $ids;
	}


	function finalize($ids) { DH_ConvDB::finalize($ids); }


	function clean() {
		global $gCfg;
		unlink($this->flv_raw);
		$dump = $gCfg['storage']['dir_dump'];

		if ($dump and glob($dump)) {
			if (flag('d')) echo "--- Clean: dump = $dir_dump\n";
			$dir_dump = $dump.DS.String::seg($this->video);
			if (!glob($dir_dump)) mkdir($dir_dump, 0755, true);
			rename($this->video, dirname($this->video).DS.basename($this->video));
			rename($this->sub, dirname($this->sub).DS.basename($this->sub));
		}
	}


	function status($status, $message = null) {
		DH_ConvDB::status($this->id, $status);
		$this->status = $status;
		if (!is_null($message)) $this->log($message);
		return $this->status;
	}


	function log($message) {
		if (is_array($message)) $message = implode("\n", $message);
		return DH_ConvDB::log($this->id, $message);
	}


}
