<?
include('core.php');

$gCl = CLI::parse_cl();
extract($gCl);
function flag($flag) { return in_array($flag, $GLOBALS['gCl']['flags']); }

foreach ($gCfg['storage'] as $var => &$value) if (isset($vars[$var]) and !empty($vars[$var])) $value = $vars[$var];

if (flag('h')) {
?>
Syntax:
	conv [-flags] [--cfg_var=new_value] [path]
	Where flags, cfg_vars and paths can be written in any order and amount, flags can be grouped together.

Examples:
	conv /mnt/anime
	conv -fRp --table_jobs=jobs_test /mnt/anime
	conv -p --dir_out=/mnt/databank/flv2 /mnt/anime -Rf --table_paths=paths_serv2 /mnt/anime_unfinished
	conv -Z

Flags:
	none = parse path, if not parsed already, adding only jobs without errors, then start unstarted jobs in it one-by-one, commiting them to postproc table

	d - operational debug - write all cmd's output to DB, echo progress to stdout
	D - developer debug - echo lots of key info in unreadable format
	f - force - ignore all errors
	s - strict - skip paths with any errors
	v - verbose - print jobs' errors on path parsing
	p - pretend - don't start jobs, just print 'em

	n - no-postproc - don't commit finished jobs to postproc table
	z - finalize - update site tables from postproc table, removing processed entries from it. Ignores -n flag if set
	c - clean - move processed files to dir_dump

	r - soft retry - retry unfinished and failed jobs
	R - hard retry - re-parse path (remove and re-add path and all jobs)
	F - flush - flush all job control tables first (clean all path/job data). Like -R, but also removes any other parsed paths
	N - new run - remove all entries from postproc table
	Z - second pass - parse postproc table, commiting all entries to site tables, then exit. Ignores any other flags.
<?
	exit;
}

DH_ConvFS::touch();
$gSh = "export HOME=".escapeshellarg($gCfg['storage']['dir_tmp']).' && ';

if (flag('Z')) {
	DH_ConvDB::finalize();
	exit;
}

DH_ConvDB::touch(flag('F'), flag('N'));

$paths = $args;
foreach ($paths as $path) {
	if (flag('R')) DH_ConvDB::flush($path);
	$path_id = DH_ConvDB::path($path);
	if (!$path_id) {
		$entries = DH_ConvFS::get_entries($path);
		$matches = array();
		foreach ($entries as $subpath) {
			$subs = DH_ConvFS::get_subs($subpath);
			$videos = DH_ConvFS::get_videos($subpath);
			if (empty($videos)) continue;
			$matches = array_merge($matches, DH_ConvFS::match_subs($videos, $subs));
		}
		if (!$gErr or !flag('s')) $path_id = DH_ConvDB::add_path($path, $matches);
		else $path_id = false;
	}

	if ($path_id) {
		$status_mask = flag('r') ? Job::ST_UNFINISHED : Job::ST_UNSTARTED;
		while ( $entry = DH_ConvDB::fetch($path_id, $status_mask, flag('p')) ) {
			$job = new Job_Convert($entry['id'], $entry['video'], $entry['sub']);
			if (!flag('p')) $job->commence();
			else echo "JOB\tID: $job->id, Name: $job->name\nIN\tVideo: $job->video, Sub: $job->sub\nOUT\tFLV: $job->flv\n\n";
		}

		echo "Path $path conversion completed.";
		if ("$gErr") {
			echo " Errors:\n";
			echo $gErr;
			$gErr->flush();
		}
	}

}
