<?
class DB_MySQL extends PDO {

	private $connected = false;
	private static $connect_params = array(
		'host' => 'localhost',
		'name' => 'dev',
		'username' => 'dev',
		'password' => 'dev',
		'persistent' => true,
		'buffered' => true
	);


	public static function getSocket() {
		throw new ExceptionImplementation('DB::getSocket() is deprecated in favor of gDb');
		global $gDb;
		if (!isset($gDb)) {
			$ini_data = ConfigCacheHelper::getAppCache('db');
			$connect_params = !empty($ini_data) ? $ini_data['mysql'] : array();
			$gDb = new self($connect_params);
		}
		return $gDb;
	}


	function __construct($connect_params) {
		self::$connect_params = array_merge(self::$connect_params, $connect_params);
		$this->connect();
	}


	private function connect() {
		if ($this->connected) return true;
		extract(self::$connect_params);
		parent::__construct("mysql:host=$host;dbname=$name", $username, $password,
			array(
				PDO::ATTR_PERSISTENT => $persistent,
				PDO::MYSQL_ATTR_USE_BUFFERED_QUERY => $buffered,
				PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION
			)
		);
		if (!empty($charset)) {
			$this->e("SET CHARSET $charset");
			$this->e("SET NAMES $charset");
		}
		$this->connected = true;
	}


	function likeEscape($str) {
		return str_replace(array('%', '_'), array('\%', '\_'), $str);
	}


	function likeQuote($str) {
		$str = $this->quote($this->likeEscape($str));
		return $str;
	}


	function likeQuery($str) {
		$str = $this->quote('%'.$this->likeEscape($str).'%');
		return $str;
	}


	function num($number) {
		if (!ctype_digit("$number")) throw new ExceptionDatahandle("Attempt to inject unquoted non-numeric value \"$number\" into DB");
		return sprintf('%d', $number);
	}


	function e() {
		$params = func_get_args();
		return call_user_func_array(array($this,'exec'), $params);
	}


	function q() {
		$params = func_get_args();
		return call_user_func_array(array($this,'query'), $params);
	}


	function val($q, $columns = null, $where = null) {
		$request = $this->parseRequest($columns, $where);
		if ($request) $q = "SELECT {$request['columns']} FROM $q {$request['where']} LIMIT 1";
		$ret = $this->line($q, false);
		return $ret ? current($ret) : false;
	}


	function line($q, $ass = true, $columns = null, $where = null) {
		$request = $this->parseRequest($columns, $where);
		if ($request) $q = "SELECT {$request['columns']} FROM $q {$request['where']} LIMIT 1";
		$sth = $this->query($q);
		$arr = $sth->fetch($ass ? PDO::FETCH_ASSOC : PDO::FETCH_NUM);
		unset($sth);
		return $arr ? $arr : array();
	}


	function data($table, $columns, $where = null, $limit = null) {
		if (!is_array($columns)) {
			if (!$limit) {
				if (strpos($columns, ',')) return $this->val($table, $columns, $where);
				else return $this->line($table, $columns, $where);
			}
		} else {
			if (count($columns) > 1) return $this->arr($table, true, $columns, $where, $limit);
			else return $this->row($table, $columns, $where, $limit);
		}
	}


	function arr($q, $ass = true, $columns = null, $where = null, $limit = null) {
		$request = $this->parseRequest($columns, $where, $limit);
		if ($request) $q = "SELECT {$request['columns']} FROM $q {$request['where']} {$request['limit']}";
		$sth = $this->prepare($q);
		try { $sth->execute(); } catch (PDOException $ex) { var_dump($request, $q); exit; }
		$arr = $sth->fetchAll($ass ? PDO::FETCH_ASSOC : PDO::FETCH_NUM);
		unset($sth);
		return $arr ? $arr : array();
	}


	function row($q, $columns = null, $where = null, $limit = null) {
		$request = $this->parseRequest($columns, $where, $limit);
		if ($request) $q = "SELECT {$request['columns']} FROM $q {$request['where']} {$request['limit']}";
		$arr = $this->arr($q, false);
		if (isset($arr[0]) and is_array($arr[0])) foreach($arr as &$one) $one = reset($one);
		return $arr ? $arr : array();
	}


	function ass($q, $columns = null, $where = null, $limit = null) {
		$request = $this->parseRequest($columns, $where, $limit);
		if ($request) $q = "SELECT {$request['columns']} FROM $q {$request['where']} {$request['limit']}";
		$arr = array();
		foreach($this->arr($q, false) as $one) $arr[$one[0]] = $one[1];
		return $arr;
	}


	function obj($q, $class, $columns = null, $where = null, $limit = null) {
		$request = $this->parseRequest($columns, $where, $limit);
		if ($request) $q = "SELECT {$request['columns']} FROM $q {$request['where']} {$request['limit']}";
		$a = $this->arr($q);
		foreach ($a as &$one) $one = new $class($one);
		return $a;
	}


	private function parseRequest($columns = null, $where = null, $limit = null) {
		if (!$columns and !$where and !$limit) return false;
		if ($columns and is_array($columns)) $columns = implode(', ', $columns);
		if ($where) $where = 'WHERE '.(is_array($where) ? implode(' AND ', $this->arrayToQuery($where)) : $where);
		if ($limit) $limit = 'LIMIT '.$limit;
		return compact('columns', 'where', 'limit');
	}


	public function arrayToQuery($values) {
		$values = $this->quoteArray($values);
		foreach ($values as $key=>&$value) $value = is_array($value) ? $key.' IN ('.implode(',',$values).')' : "$key = $value";
		return $values;
	}


	private function quoteArray($values, $types = array()) {
		if (!is_array($values)) throw new Exception;
		$i = 0;
		foreach ($values as &$value) {
			if (isset($types[$i])) $type = $types[$i];
			else {
				if (is_null($value)) $type = DB::NULL;
				elseif (is_numeric($value)) $type = DB::NUMERIC;
				elseif (is_array($value)) {
					$value = array_values($value);
					if ((count($value) === 2) and is_array($value[0]) and is_array($value[1])) $value = $this->quoteArray($value[0], $value[1]);
					else $value = $this->quoteArray($value);
					$type = DB::SKIP;
				}
				else $type = DB::STRING;
			}
			switch ($type) {
				case DB::NULL:
					$value = 'NULL';
					break;
				case DB::NUMERIC:
					break;
				case DB::SKIP:
					break;
				default:
					$value = $this->quote($value);
			}
			$i++;
		}
		return $values;
	}


	function upd($table, $values = array(), $where = null, $limit = null) {
		$values = $this->arrayToQuery($values);
		$request = $this->parseRequest(null, $where, $limit);
		$values = implode(', ', $values);
		$q = "UPDATE $table SET $values {$request['where']} {$request['limit']}";
		return $this->e($q);
	}


	function ins($table, $values = array(), $types = array()) {
		$values = $this->quoteArray($values, $types);
		$keys = implode(', ', array_keys($values));
		$values = implode(', ', $values);
		$q = "INSERT INTO $table ($keys) VALUES ($values)";
		$insert = $this->e($q);
		if (!$insert) return $insert;
		return $this->lastInsertId();
	}


	// Multiline insert. Faster, returns only last id
	function inject($table, $values = array(), $types = array()) {
		$keys = implode(', ', array_keys(reset($values)));
		$data = array();
		foreach ($values as $row) $data[] = '('.implode(',', $this->quoteArray($row, $types)).')';
		$data = implode(', ', $data);
		$q = "INSERT INTO $table ($keys) VALUES $data";
		$insert = $this->e($q);
		if (!$insert) return $insert;
		return $this->lastInsertId();
	}


	// Multiline insert. Slower, returns ids row
	function import($table, $values = array(), $types = array()) {
		$keys = implode(', ', array_keys(reset($values)));
		$ids = array();
		foreach ($values as $row) {
			$row = implode(',', $this->quoteArray($row, $types));
			$q = "INSERT INTO $table ($keys) VALUES ($row)";
			$insert = $this->e($q);
			if (!$insert) $ids[] = $insert;
			else $ids[] = $this->lastInsertId();
		}
		return $ids;
	}


	function rep($table, $values = array()) {
		$values = $this->quoteArray($values);
		$keys   = implode(', ', array_keys($values));
		$values = implode(', ', $values);
		$q = "REPLACE INTO $table ($keys) VALUES ($values)";
		$insert = $this->e($q);
		if (!$insert) return $insert;
		return $this->lastInsertId();
	}


	function del($table, $where = null, $limit = null) {
		$request = $this->parseRequest(null, $where, $limit);
		$q = "DELETE FROM $table {$request['where']} {$request['limit']}";
		return $this->e($q);
	}


}
