<?
class ProtoErr {

	protected $data;
	protected $extension;


	function __construct($errors = null) {
		$this->extension = get_class($this);
		if (is_array($errors)) {
			foreach ($errors as $id => $sublevel) {
				if (!is_array($sublevel)) $this->$id = $sublevel;
				else $this->$id = new $this->extension($sublevel);
			}
		}
	}


	function __get($id) {
		if (is_callable(array($this, "get_$id"))) return call_user_func(array($this, "get_$id"));
		elseif (!isset($this->data[$id])) return $this->data[$id] = new $this->extension;
		else return $this->data[$id];
	}


	function __set($id, $value) {
		if (is_array($value)) foreach ($value as $sub_id => $sub_val) $this->__set($sub_id, $sub_val);
		else $this->data[$id] = $value;
		//~ if (!isset($this->data[$id])) $this->data[$id] = $value;
	}


	function __unset($id) {
		if (isset($this->data[$id])) unset($this->data[$id]);
	}


	function __isset($id) {
		return isset($this->data[$id]);
	}


	function __toString() {
		if (is_array($this->data)) return (string) implode("\n", $this->data);
		else return (string) $this->data;
	}


	function get_export() {
		$level = array();
		if (is_array($this->data)) {
			foreach($this->data as $sublevel_id => $sublevel) $level[$sublevel_id] = is_object($sublevel) ? $sublevel->export : $sublevel;
			return $level;
		} else return $this->data;
	}


	static function get($path, $error_file = 'errors.xml') {
		global $gCfg;
		$error_file = glob($path.DS.$error_file);
		if ($error_file) return new self(XML::parse(simplexml_load_file(current($error_file))));
		else return new self;
	}


	function dump($path, $error_file = 'errors.xml') {
		global $gCfg;
		if (!$path) throw new ExceptionError('Empty dump path given');
		$error_file = $path.DS.$error_file;
		return file_put_contents($error_file, $this->export_xml->asXML());
	}


	function flush() {
		return $this->data = null;
	}


	function get_export_xml(&$level = null) {
		if (is_null($level)) $level = new simpleXMLElement("<?xml version='1.0' standalone='yes'?><errors></errors>");
		if (is_array($this->data)) {
			foreach ($this->data as $sublevel_id => $sublevel) {
				if (is_int($sublevel_id)) $sublevel_id = "i_$sublevel_id";
				if (!is_object($sublevel)) $level->$sublevel_id = $sublevel;
				else $sublevel->get_export_xml($level->$sublevel_id);
			}
			return $level;
		} else return $this->data;
	}


}
