<?
class String {


	static function arrayToString($mixed = null) {
		ob_start();
		var_export($mixed);
		$content = ob_get_contents();
		ob_end_clean();
  	return $content;
	}


	static function prefix($prefix, $data) {
		if (is_array($data)) {
			if (!is_array($prefix)) foreach ($data as &$value) $value = $prefix.$value;
			else foreach ($data as $key => &$value) if (isset($prefix[$key])) $value = $prefix[$key].$value;
		} else $data = (!is_array($prefix)) ? $prefix.$data : reset($prefix).$data;
		return $data;
	}


	static function fs_hash($string) {
		return md5($string);
	}


	static function underscore($word) {
  	$word = preg_replace('/([[:alpha:]][a-z]+)/', "$1_", $word);
  	$word = strtolower(preg_replace('/([[:digit:]]+)/', "$1_", $word));
  	$length = strlen($word);
  	$word = substr($word, 0, $length - 1);
  	return $word;
	}


	static function url_ruDecode($str) {
		$str = str_replace('%20', ' ', $str);
		$str1 = preg_replace_callback('/%(D[01])%([0-9A-F]{2})/i', array('self', '_ruIeConv'), $str);
		$str2 = preg_replace_callback('/%([A-F][A-F0-9])/i', array('self', '_ruFfConv'), $str1);
		// if ($str1 !== $str2) echo 'FireFox!';
		return $str2;
	}


	private static function _ruIeConv($multibyte) {
		$ho = base_convert($multibyte[1], 16, 10);
		$lo = base_convert($multibyte[2], 16, 10);
		if ($ho == 208 && $lo >= 176 && $lo <= 191) return chr($lo+48);
		if ($ho == 209 && $lo >= 128 && $lo <= 143) return chr($lo+112);
		if ($ho == 209 && $lo == 145) return 'ё';
		if ($ho == 208 && $lo >= 144 && $lo <= 175) return chr($lo+48);
		if ($ho == 208 && $lo == 129) return 'Ё';
		return $multibyte[0];
	}


	private static function _ruFfConv($multibyte) {
		return chr(base_convert($multibyte[1], 16, 10));
	}


	static function uEncode($data) {
		if (is_array($data)) {
			foreach($data as &$one) $one = self::uEncode($one);
			return $data;
		}

		if (self::uCheck($data)) return $data;
		else return iconv('WINDOWS-1251', 'UTF-8//IGNORE', $data);
	}


	static function uDecode($data) {
		if (is_array($data)) {
			foreach($data as &$one) $one = self::uDecode($one);
			return $data;
		}
		if (self::uCheck($data)) return iconv('UTF-8', 'WINDOWS-1251//IGNORE', $data);
		else return $data;
	}


	static function uCheck($string) {
		return preg_match('#[а-яА-Я]#u', $string) ? true : false;
	}


	static function crop($path, $separator = '/', $levels = 1) {
		$path = explode($separator, $path);
		return implode($separator, array_slice($path, -$levels));
	}


	static function root($path, $separator = '/', $levels = 1) {
		$path = explode($separator, $path);
		return implode($separator, array_slice($path, 0, $levels));
	}


	static function seg($path, $level = -2, $separator = '/') {
		$path = explode($separator, $path);
		$seg = array_slice($path, $level, 1);
		return reset($seg);
	}


	static function depth($path, $separator = '/') {
		$path = array_diff(explode($separator, $path), array(''));
		return count($path);
	}


	static function diff($parent, $child, $separator = null) {
		return str_replace($parent, '', str_replace($separator.$parent, '', $child));
	}

	static function base($path, $separator = '/') {
		return self::diff(self::crop($path, $separator), $path, $separator);
	}


	static function breakdown($line, $separator = ',') {
		$line = explode(',', $line);
		$result = array();
		$i = 0;
		$aggregate = false;
		foreach ($line as $piece) {
			if ($aggregate) $result[$i-1] .= ','.$piece;
			else {
				$result[$i] = trim($piece);
				$i++;
			}
			if (!$aggregate and (strpos($piece, '(') !== false) and (strpos($piece, ')') === false)) $aggregate = true;
			elseif ($aggregate and (strpos($piece, ')') !== false)) $aggregate = false;
		}
		return $result;
	}


}
