<?
include('core.php');

$gCl = CLI::parse_cl();
extract($gCl);
foreach ($gCfg as $section=>$data) {
	if ( !is_array($data) and (isset($vars[$section]) and !empty($vars[$section])) ) $gCfg[$section] = $vars[$section];
	else {
		foreach ($data as $var=>$value) if (isset($vars[$var]) and !empty($vars[$var])) $data[$var] = $vars[$var];
		$gCfg[$section] = $data;
	}
}

if (in_array('h', $flags)) {
?>
Syntax:
	log_parser [-flags] [--cfg_var=new_value]
	Where flags and cfg_vars can be written in any order and amount, flags can be grouped together.


Examples:
	log_parser -h
	log_parser --ftp_log=/var/log/proftpd/237.T.log


Flags:
	none = parse log, specified in config.ini, update ratings, write final timestamp
	h - help - display this help and exit
	f - force - parse all entries, ignoring timestamps
	t - test run - do not write final timestamp to config
	p - pretend - echo path comparison info, overall results, but do not update tables. Implies -t flag
	d - debug - create permanent tables instead of temporary, do not drop them, stop execution on all errors
<?
	exit;
}

$log_files = glob($gCfg['storage']['ftp_log']);
if (empty($log_files)) exit;

DH_LogDB::touch();

$ips_used = array();
foreach ($log_files as $file) {
	$log = fopen($file, 'r');
	while (!feof($log)) {
		// Sat Jan 19 18:30:29 2008 104 90.151.137.144 961180 /mnt/databank/anime/Futari_Ecchi/Futari_Ecchi_-_01_[Triad].avi b _ o a yourname@yourcompany.com ftp 0 * i
		$line = fgets($log);
		$video_formats = '('.implode(')|(', $gCfg['types']['video']).')';
		if (!preg_match("/^(.{24}) \d+ (\d+\.\d+\.\d+\.\d+) (\d+) (.+\.($video_formats) )/", $line, $fields)) continue;
		$timestamp = strtotime($fields[1]);
		$ip = $fields[2];
		$size = $fields[3];
		$path = (mb_substr($fields[4], 0, mb_strlen($gCfg['storage']['ftp_root'])) == $gCfg['storage']['ftp_root']) ? trim(mb_substr($fields[4], mb_strlen($gCfg['storage']['ftp_root']))) : trim($fields[4]);
		$dir = basename(dirname($path));
		if (in_array('p', $flags)) {
			echo 'Got path_line: '.$path.' -> '.$dir.". Checking:\n";
			echo 'Timestamp... '.( (in_array('f', $flags) or ($timestamp > $gCfg['cron']['last_update'])) ? 'OK' : 'Old' )."\n";
			echo 'IP/Dir combo... '.( (!isset($ips_used[$dir]) or !in_array($ip, $ips_used[$dir])) ? 'OK' : "Used ($ip)" )."\n";
		}

		if ( (in_array('f', $flags) or ($timestamp > $gCfg['cron']['last_update'])) and (!isset($ips_used[$dir]) or !in_array($ip, $ips_used[$dir])) ) {
			if (in_array('p', $flags)) echo 'Commiting line... ';
			try {
				DH_LogDB::log_entry($dir, $ip, $size, $timestamp);
				$ips_used[$dir][] = $ip;
				if (in_array('p', $flags)) echo "Success (ip: $ip)\n\n";
			} catch (PDOException $ex) {
				if ($ex->getCode != DB::ERR_EXISTS) throw $ex;
				if (in_array('p', $flags)) echo "Failure: duplicate (ip: $ip)\n\n";
			}
		} elseif (in_array('p', $flags)) echo "Discarding line\n\n";
	}
	fclose($log);

	DH_LogDB::commit();
	if (!in_array('d', $gCl['flags'])) DH_LogDB::clean();
}

	// OBSOLETE
	//~ if (filesize($file) > 2000000) {
		//~ file_put_contents($cron_settings['log_dump'], file_get_contents($file), FILE_APPEND | FILE_TEXT);
		//~ $log = fopen($file, 'w');
		//~ ftruncate($log, 0);
		//~ fclose($log);
	//~ }

if (!in_array('t', $flags) and !in_array('p', $flags)) FS::ini_update($gCfg_file, array('last_update' => $timestamp), array('last_update' => $gCfg['cron']['last_update']));
