<?
include('core.php');

$gCl = CLI::parse_cl();
extract($gCl);
function flag($flag) { return in_array($flag, $GLOBALS['gCl']['flags']); }

foreach ($gCfg as $section => $data) {
	if ( !is_array($data) and (isset($vars[$section]) and !empty($vars[$section])) ) $gCfg[$section] = $vars[$section];
	else {
		foreach ($data as $var=>$value) if (isset($vars[$var]) and !empty($vars[$var])) $data[$var] = $vars[$var];
		$gCfg[$section] = $data;
	}
}

if (empty($flags) or flag('h')) {
?>
Syntax:
	sanity [-flags] [--cfg_var=new_value] [optional flag args (see flags)]
	Where flags, cfg_vars and optional arguments can be written in any order and amount, flags can be grouped together.


Flags:
	none = display this help and exit
	h - help - display this help and exit
	p - pretend - dry-run, if implemented
	c - compare - try some test comparison fn
	s - scavenge - roam shots / flv tables and scavenge all necessary data from duplicate entries
	t - inject test data - never use without looking at it's code, very dangerous
	r - path fix - parses movie_file table, assigning their paths to all movies which have at least one associated file, leaving rest untouched
	R - reverse path fix - parse all dirs on ftp and compare them to path table, showing/fixing diffs; replace all spaces with '_' in paths
<?
	exit;
}

$db = DB::get($gCfg['animebase']);

if (flag('r')) {
	$movies = $db->arr('SELECT movie_id, path FROM m_movie_file GROUP BY movie_id');
	foreach ($movies as $movie) $db->upd('m_movie', array('path' => dirname($movie['path'])), "movie_id = {$movie['movie_id']}", 1);
}

if (flag('R')) {
	$path_table = $gCfg['storage']['table_base'];
	$ftp_root = opendir($gCfg['storage']['ftp_root']);
	$paths_skip = array('.', '..', 'upload');
	while ($path = readdir($ftp_root)) {
		if (in_array($path, $paths_skip)) {
			if (flag('p')) echo "Skipping path '$path'\n";
			continue;
		}
		$no_match = false;

		$no_match = (bool) ( !$db->val($path_table, 'movie_id', compact('path')) );
		if ($no_match) {
			echo "Path '$path' wasn't found in table ($path_table)\n";
			$unstrict = 'path LIKE '.$db->quote($path);
			$matches = $db->val($path_table, 'COUNT(*)', $unstrict);
			if (flag('p') and $matches) echo "Found $matches unstrict match(es) for path\n";
			elseif ($matches > 1) echo "More than one unstrict match for path = '$path', skipping sync\n";
			elseif ($matches == 1) {
				echo "Found unstrict match, fixed\n";
				$db->upd($path_table, compact('path'), $unstrict);
				$no_match = false;
			}
		}

		if (!$no_match and (strpos($path, ' ') !== false)) {
			$path_new = preg_replace('/\s+/', '_', $path);
			echo "Found whitespaces in path '$path', converted to '$path_new'\n";
			if (!flag('p')) {
				$dir_old = $gCfg['storage']['ftp_root'].DS.$path;
				$dir_new = $gCfg['storage']['ftp_root'].DS.$path_new;
				$success = rename($dir_old, $dir_new);
				if ($success) {
					$db->upd($path_table, array('path' => $path_new), compact('path'));
					$path = $path_new;
					if ( !$db->val($path_table, 'movie_id', compact('path')) ) echo "DB update with new path ('$path') failed\n";
				} else echo "Rename of $dir_old to $dir_new failed\n";
			}
		}
	}
}

if (flag('c')) {
	$path[] = '/waka/yoyo/123.avi';
	$path[] = 'waka/yoyo/123.avi';
	$path[] = '/waka2/waka/yoyo/123.avi';
	foreach ($path as $i => $dir) $path[$i] = basename(dirname($dir));
	var_dump($path);
}

if (flag('s')) {
	$type_id = $gCfg['types']['out_shot_type_id'];
	$img_ext = '.'.$gCfg['types']['image'][$type_id];

	$checkpoint = 0;
	while ($entry = $db->line("SELECT s.shot_id, f.id AS flv_id, f.video_id, s.sort FROM m_movie_shot AS s LEFT JOIN flv_list AS f ON s.shot_id = f.shot_id WHERE s.shot_id > $checkpoint LIMIT 1")) {

		if (flag('p')) echo "\nGot True_entry: Video={$entry['video_id']} Shot={$entry['shot_id']}\n";
		$shot_path_true = $gCfg['storage']['dir_usr_shot'].DS.$entry['shot_id'].$img_ext;
		$fs_shot = is_file($shot_path_true);
		if (!$fs_shot and is_file(str_replace($img_ext, '.', $shot_path_true))) {
			if (!flag('p')) rename(str_replace($img_ext, '.', $shot_path_true), $shot_path_true);
			else echo "--- FS_Rename: ".str_replace($img_ext, '.', $shot_path_true)." -> ".$shot_path_true."\n";
			$fs_shot = true;
		}

		$flv_path_true = $gCfg['storage']['dir_usr'].DS.$entry['flv_id'].'.'.$gCfg['types']['out'];
		$fs_flv = is_file($flv_path_true);

		$thumb_path_true = $gCfg['storage']['dir_usr'].DS.$entry['flv_id'].$img_ext;
		$fs_thumb = is_file($thumb_path_true);
		if (!$fs_thumb and is_file(str_replace($img_ext, '.', $shot_path_true))) {
			if (!flag('p')) rename(str_replace($img_ext, '.', $thumb_path_true), $thumb_path_true);
			else echo "--- FS_Rename: ".str_replace($img_ext, '.', $thumb_path_true)." -> ".$thumb_path_true."\n";
			$fs_thumb = true;
		}

		$sort_true = $entry['sort'];

		while ($subentry = $db->line("SELECT s.shot_id, f.id AS flv_id, f.video_id, s.sort FROM m_movie_shot AS s LEFT JOIN flv_list AS f ON s.shot_id = f.shot_id WHERE f.video_id = {$entry['video_id']} AND s.sort = $sort_true AND s.shot_id != {$entry['shot_id']} LIMIT 1")) {
			$shot_path = $gCfg['storage']['dir_usr_shot'].DS.$subentry['shot_id'].$img_ext;
			$flv_path = $gCfg['storage']['dir_usr'].DS.$subentry['flv_id'].'.'.$gCfg['types']['out'];
			$thumb_path = $gCfg['storage']['dir_usr'].DS.$subentry['flv_id'].$img_ext;

			$shot = is_file($shot_path);
			if (!$shot and is_file(str_replace($img_ext, '.', $shot_path))) {
				if (!flag('p')) rename(str_replace($img_ext, '.', $shot_path), $shot_path);
				else echo "--- FS_Rename: ".str_replace($img_ext, '.', $shot_path)." -> ".$shot_path."\n";
				$shot = true;
			}
			$flv = is_file($flv_path);
			$thumb = is_file($thumb_path);
			if (!$thumb and is_file(str_replace($img_ext, '.', $shot_path))) {
				if (!flag('p')) rename(str_replace($img_ext, '.', $thumb_path), $thumb_path);
				else echo "--- FS_Rename: ".str_replace($img_ext, '.', $thumb_path)." -> ".$thumb_path."\n";
				$thumb = true;
			}

			if (!$fs_shot) {
				if (!flag('p')) copy($shot_path, $shot_path_true);
				else echo "--- FS_Copy: $shot_path -> $shot_path_true\n";
			}
			if (!$fs_flv) {
				if (!flag('p')) copy($flv_path, $flv_path_true);
				else echo "--- FS_Copy: $flv_path -> $flv_path_true\n";
			}
			if (!$fs_thumb) {
				if (!flag('p')) copy($thumb_path, $thumb_path_true);
				else echo "--- FS_Copy: $thumb_path -> $thumb_path_true\n";
			}

			if ($shot) {
				if (!flag('p')) unlink($shot_path);
				else echo "--- FS_Unlink: $shot_path\n";
			}
			if ($flv) {
				if (!flag('p')) unlink($flv_path);
				else echo "--- FS_Unlink: $flv_path\n";
			}
			if ($thumb) {
				if (!flag('p')) unlink($thumb_path);
				else echo "--- FS_Unlink: $thumb_path\n";
			}

			if (flag('p')) {
				echo "--- DB_Del: shot_id = {$subentry['shot_id']}\n";
				echo "--- DB_Del: flv_id = {$subentry['flv_id']}\n";
			} else {
				$db->del('m_movie_shot', "shot_id = {$subentry['shot_id']}");
				$db->del('flv_list', "id = {$subentry['flv_id']}");
			}
		}

		$checkpoint = $entry['shot_id'];
	}
}

if (flag('t')) {
	$pool = '/mnt/databank/flv_pool';
	$fd = '/mnt/databank/flv';
	$sd = '/www/anime_lhttpd/web/image/shot/full';

	$movie_id = 4;
	$actual = 1;
	$type_id = 2;
	$data_add = Time::now();
	$shots = glob($pool.DS.'img'.DS.'Kidou_Senkan_Nadesico_*');
	foreach ($shots as $shot) {
		$title = String::base(basename($shot), '.');
		if (preg_match('/\d+/', $title, $num)) $sort = (int) reset($num);
		else $sort++;

		if (flag('p')) echo "\n".var_dump($shot_id = $sort, compact('movie_id', 'type_id', 'data_add', 'actual', 'title', 'sort'));
		else {
			$shot_id = $db->ins('m_movie_shot', compact('movie_id', 'type_id', 'data_add', 'actual', 'title', 'sort'));
			rename($shot, $sd.DS.$shot_id.'.'.$gCfg['types']['image'][$type_id]);
		}

		if (is_file($path = $pool.DS.$title.'.'.$gCfg['types']['out'])) {
			if (flag('p')) echo "\n".var_dump($flv_id = $shot_id, compact('movie_id', 'shot_id', 'path'))."\n";
			else {
				$flv_id = $db->ins('flv_list', compact('movie_id', 'shot_id', 'path'));
				rename($path, $fd.DS.$flv_id.'.'.$gCfg['types']['out']);
			}
		}
	}
}
